VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmContainer 
   Caption         =   "Container Object"
   ClientHeight    =   5340
   ClientLeft      =   120
   ClientTop       =   1935
   ClientWidth     =   11010
   LinkTopic       =   "Form1"
   ScaleHeight     =   5340
   ScaleWidth      =   11010
   Begin VB.Frame Frame1 
      Caption         =   "Frame1"
      Height          =   3135
      Index           =   1
      Left            =   5880
      TabIndex        =   3
      Top             =   240
      Width           =   4815
   End
   Begin VB.Frame Frame1 
      Caption         =   "Frame1"
      Height          =   3615
      Index           =   0
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   5535
   End
   Begin VB.TextBox Text1 
      Height          =   1215
      Index           =   0
      Left            =   120
      TabIndex        =   1
      Text            =   "Text1"
      Top             =   3840
      Width           =   3615
   End
   Begin MSComctlLib.TabStrip TabStrip1 
      Height          =   975
      Index           =   1
      Left            =   6480
      TabIndex        =   0
      Top             =   4080
      Width           =   4095
      _ExtentX        =   7223
      _ExtentY        =   1720
      _Version        =   393216
      BeginProperty Tabs {1EFB6598-857C-11D1-B16A-00C0F0283628} 
         NumTabs         =   4
         BeginProperty Tab1 {1EFB659A-857C-11D1-B16A-00C0F0283628} 
            Caption         =   "One"
            ImageVarType    =   2
         EndProperty
         BeginProperty Tab2 {1EFB659A-857C-11D1-B16A-00C0F0283628} 
            Caption         =   "Two"
            ImageVarType    =   2
         EndProperty
         BeginProperty Tab3 {1EFB659A-857C-11D1-B16A-00C0F0283628} 
            Caption         =   "Three"
            ImageVarType    =   2
         EndProperty
         BeginProperty Tab4 {1EFB659A-857C-11D1-B16A-00C0F0283628} 
            Caption         =   "Four"
            ImageVarType    =   2
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "frmContainer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Copy into general declarations
Dim X1 As Single, Y1 As Single
Private Sub StartDrag(Source As Control, X As Single, Y As Single)
        Source.Tag = "Drag"
        'Stores the initial X and Y of the mouse on the drag object
        X1 = X
        Y1 = Y
        Source.Drag
End Sub
Private Sub StopDrag(Source As Control, Target As Object, X As Single, Y As Single)
    On Error Resume Next
    If Source.Tag <> Target.Tag Then 'not dropped on itself
        'Check target for valid container type
        If TypeOf Target Is Form Or TypeOf Target Is Frame Or TypeOf Target Is PictureBox Then
            'Set the container to target object
            Set Source.Container = Target
            Source.Left = X - X1
            Source.Top = Y - Y1
        Else 'Target is not a Container
            'Is the target an object within itself
            If Source.Tag <> Target.Container.Tag Then
                'Set the container to target object's container
                Set Source.Container = Target.Container
                Source.Left = Target.Left + (X - X1)
                Source.Top = Target.Top + (Y - Y1)
            Else
                If X > X1 Then Source.Left = Source.Left + Target.Left + (X - X1) Else Source.Left = Source.Left - (X1 - X)
                If Y > Y1 Then Source.Top = Source.Top + Target.Top + (Y - Y1) Else Source.Top = Source.Top - (Y1 - Y)
           End If
        End If
    Else 'Dropped on itself
        If X > X1 Then Source.Left = Source.Left + (X - X1) Else Source.Left = Source.Left - (X1 - X)
        If Y > Y1 Then Source.Top = Source.Top + (Y - Y1) Else Source.Top = Source.Top - (Y1 - Y)
    End If
    Source.Tag = ""
End Sub

Private Sub Form_DragDrop(Source As Control, X As Single, Y As Single)
    'Copy this code into the dragDrop Event of the Target object
    StopDrag Source, frmContainer, X, Y
    Source.ZOrder 0 'Add if you want the control moved to the front
End Sub
Private Sub Frame1_DragDrop(Index As Integer, Source As Control, X As Single, Y As Single)
    'Copy this code into the dragDrop Event of the Target object
    StopDrag Source, Frame1(Index), X, Y
    Source.ZOrder 0 'Add if you want the control moved to the front
End Sub

Private Sub Frame1_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    'Copy this code into the MouseDown Event of the drag object
    If Shift = 1 Then StartDrag Frame1(Index), X, Y
End Sub

Private Sub Picture1_DragDrop(Source As Control, X As Single, Y As Single)
    'Copy this code into the dragDrop Event of the Target object
    StopDrag Source, Picture1, X, Y
    Source.ZOrder 0 'Add if you want the control moved to the front
End Sub

Private Sub Picture1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Shift = 1 Then StartDrag Picture1, X, Y
End Sub

Private Sub TabStrip1_DragDrop(Index As Integer, Source As Control, X As Single, Y As Single)
    'Copy this code into the dragDrop Event of the Target object
    StopDrag Source, TabStrip1(Index), X, Y
    Source.ZOrder 0 'Add if you want the control moved to the front
End Sub

Private Sub TabStrip1_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    'Copy to MouseDown Event of all objects to drag
    If Shift = 1 Then StartDrag TabStrip1(Index), X, Y
End Sub

Private Sub Text1_DragDrop(Index As Integer, Source As Control, X As Single, Y As Single)
    'Copy this code into the dragDrop Event of the target object
    StopDrag Source, Text1(Index), X, Y
    Source.ZOrder 0 'Add if you want the control moved to the front
End Sub
Private Sub Text1_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Shift = 1 Then StartDrag Text1(Index), X, Y
End Sub
